diff --git a/lib/hive.rb b/lib/hive.rb
index b22bfe0e..fa9268d5 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -62,7 +62,7 @@ module Hive
       # `dispatch_requests/` directory. See
       # `Hive::Daemon::DispatchRequestQueue` and
       # `Hive::Bot::DispatchRequestWriter`.
-      "hive-dispatch-request" => 2,
+      "hive-dispatch-request" => 3,
       # Reverse-direction notice the daemon writes for the bot to relay a
       # non-zero, bot-originated dispatch back to the originating Telegram
       # chat. See `Hive::Daemon::DispatchResultQueue` (ADV-1).
diff --git a/lib/hive/claude_launcher.rb b/lib/hive/claude_launcher.rb
index 15b092ae..42f80b51 100644
--- a/lib/hive/claude_launcher.rb
+++ b/lib/hive/claude_launcher.rb
@@ -127,6 +127,19 @@ module Hive
       /\Atmux \S+ below minimum/
     ].freeze
 
+    # Canonical production fixture for a no-I/O detector self-check.  Keeping
+    # it here makes the auto-retry health gate exercise the same readiness
+    # parser as a real launch, rather than duplicating test-only pane lore.
+    READY_DETECTOR_POSITIVE_PANE = "Claude Code\n\n❯\nfor agents\n".freeze
+    READY_DETECTOR_NEGATIVE_PANE = "Claude Code\n\n❯ 1. Trust this folder\nfor agents\n".freeze
+
+    def ready_detector_self_check
+      claude_ready_prompt?(READY_DETECTOR_POSITIVE_PANE) && !claude_ready_prompt?(READY_DETECTOR_NEGATIVE_PANE)
+    rescue StandardError
+      false
+    end
+    module_function :ready_detector_self_check
+
     SessionHandle = Struct.new(:task, :runner, :reestablish, keyword_init: true) do
       def send_and_wait!(prompt:, expected_output: nil, timeout_sec:,
                          status_mode: nil, log_label: nil, deadline: nil)
diff --git a/lib/hive/commands/doctor.rb b/lib/hive/commands/doctor.rb
index 99afbc08..3d63e16d 100644
--- a/lib/hive/commands/doctor.rb
+++ b/lib/hive/commands/doctor.rb
@@ -1,5 +1,6 @@
 require "json"
 require "open3"
+require "stringio"
 require "timeout"
 
 require "hive"
@@ -71,6 +72,14 @@ module Hive
         EXIT_CONFIG_ERROR
       end
 
+      # Lightweight in-process contract for daemon health gating.  Unlike
+      # #call it never writes a table or JSON envelope, so a daemon tick can
+      # consume the same configured-skill checks without scraping output.
+      def self.agent_health(config:, project_root:)
+        doctor = new(config: config, project_root: project_root, output: StringIO.new)
+        doctor.send(:check_stages) + doctor.send(:check_tmux)
+      end
+
       private
 
       def failing_status?(status)
diff --git a/lib/hive/commands/markers.rb b/lib/hive/commands/markers.rb
index f5df7df1..ec5477dd 100644
--- a/lib/hive/commands/markers.rb
+++ b/lib/hive/commands/markers.rb
@@ -5,6 +5,7 @@ require "hive/task"
 require "hive/markers"
 require "hive/lock"
 require "hive/git_ops"
+require "hive/marker_recovery"
 require "hive/stages"
 
 module Hive
@@ -97,28 +98,22 @@ module Hive
         task = Hive::Task.new(folder)
         validate_project_path_match!(task)
 
-        # Read+validate+rewrite must run under the same `.markers-lock`
-        # that `Hive::Markers.set` uses. Otherwise a concurrent
-        # `hive run` writes a NEW marker between our validation and our
-        # rewrite, and the rewrite (using the body we read pre-write)
-        # erases that fresh marker. The hive_commit follows under
-        # `with_commit_lock` to serialise hive/state branch writes
-        # against any concurrent committer (auto-heal, run loop).
-        Hive::Markers.with_markers_lock(task.state_file) do
-          marker = Hive::Markers.current(task.state_file)
-          actual = marker.name.to_s.upcase
-          unless actual == normalized
-            raise Hive::WrongStage,
-                  "hive markers clear: task #{task.slug} has marker #{actual.inspect}, " \
-                  "not #{normalized.inspect}; refusing to clear (the file may have been edited)."
-          end
-
-          match_attr_or_raise!(task, marker)
-          Hive::Markers.remove_marker(task.state_file, marker.raw)
+        marker = Hive::Markers.current(task.state_file)
+        actual = marker.name.to_s.upcase
+        unless actual == normalized
+          raise Hive::WrongStage,
+                "hive markers clear: task #{task.slug} has marker #{actual.inspect}, " \
+                "not #{normalized.inspect}; refusing to clear (the file may have been edited)."
         end
-
-        Hive::Lock.with_commit_lock(task.hive_state_path) do
-          record_hive_commit(task, normalized)
+        match_attr_or_raise!(task, marker)
+        match_attrs = parse_match_attrs.to_h
+        cleared = Hive::MarkerRecovery.new.clear!(
+          task: task, expected_name: normalized, match_attrs: match_attrs,
+          action: "markers clear #{normalized}", details: { action: "manual_clear", marker: normalized }
+        )
+        unless cleared
+          raise Hive::WrongStage,
+                "hive markers clear: task #{task.slug} changed before it could be cleared; refusing to clear a newer marker."
         end
 
         emit_success(task, normalized)
@@ -160,14 +155,6 @@ module Hive
         end
       end
 
-      def record_hive_commit(task, normalized)
-        ops = Hive::GitOps.new(task.project_root)
-        action = "markers clear #{normalized}"
-        ops.hive_commit(stage_name: "#{task.stage_index}-#{task.stage_name}",
-                        slug: task.slug,
-                        action: action)
-      end
-
       # ── Resolution (mirrors Hive::Commands::Approve) ─────────────────────
 
       def resolve_target
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index c686876b..dd72e00b 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -355,7 +355,11 @@ module Hive
         "child_kill_grace_sec" => 30,
         "child_verb_timeouts" => { "digest" => 3600, "answer-digest" => 3600 },
         "log_max_bytes" => 10_485_760,
-        "log_max_files" => 5
+        "log_max_files" => 5,
+        # Closed dependency-health recovery for two terminal marker shapes.
+        # This global switch controls all daemon terminal-marker reruns while
+        # leaving passive status observation and dead-agent reconciliation on.
+        "auto_retry" => { "enabled" => true }
       },
       # Update flow (plan 2026-05-27-002). The daemon checks the latest
       # release on a throttled cadence and, on the install.sh channel,
@@ -2225,6 +2229,17 @@ module Hive
               "(true / false); got #{autostart.inspect} (#{autostart.class})"
       end
 
+      auto_retry = daemon["auto_retry"]
+      unless auto_retry.nil? || auto_retry.is_a?(Hash)
+        raise ConfigError, "daemon.auto_retry in #{describe_source(source_path)} must be a Hash"
+      end
+      enabled_auto_retry = auto_retry && auto_retry["enabled"]
+      unless enabled_auto_retry.nil? || enabled_auto_retry == true || enabled_auto_retry == false
+        raise ConfigError,
+              "daemon.auto_retry.enabled in #{describe_source(source_path)} must be a boolean " \
+              "(true / false); got #{enabled_auto_retry.inspect} (#{enabled_auto_retry.class})"
+      end
+
       DAEMON_NUMERIC_BOUNDS.each do |key, min|
         value = daemon[key]
         next if value.nil?
diff --git a/lib/hive/daemon/auto_retry_health.rb b/lib/hive/daemon/auto_retry_health.rb
new file mode 100644
index 00000000..e4457021
--- /dev/null
+++ b/lib/hive/daemon/auto_retry_health.rb
@@ -0,0 +1,275 @@
+require "digest"
+require "fileutils"
+require "tmpdir"
+require "time"
+require "hive/agent_profiles"
+require "hive/claude_launcher"
+require "hive/commands/doctor"
+require "hive/invoked_binary"
+require "hive/secret_patterns"
+
+module Hive
+  module Daemon
+    # Bounded health bundles for the deliberately tiny recoverable-failure
+    # allowlist.  All command execution is argv-only, grouped, timed, and
+    # redacted before a result can reach an event or daemon log.
+    class AutoRetryHealth
+      STATUS_TIMEOUT_SEC = 10
+      ACTIVE_TIMEOUT_SEC = 30
+      OUTPUT_LIMIT = 4096
+      SAFE_ENV_KEYS = %w[HOME LANG LC_ALL PATH TMPDIR].freeze
+
+      Probe = Struct.new(:name, :healthy, :exit_status, :timed_out, :duration_ms,
+                         :stdout, :stderr, :fingerprint, keyword_init: true) do
+        def summary
+          { name: name, healthy: healthy, exit_status: exit_status, timed_out: timed_out,
+            duration_ms: duration_ms, fingerprint: fingerprint, stdout: stdout, stderr: stderr }
+        end
+      end
+      Bundle = Struct.new(:healthy, :reason, :probes, :cheap_fingerprint, :fingerprint, keyword_init: true)
+
+      def initialize(config_loader: Hive::Config.method(:load), project_root_resolver: nil,
+                     env: ENV, clock: -> { Process.clock_gettime(Process::CLOCK_MONOTONIC) },
+                     command_runner: nil, universal_checker: nil, invoked_binary: Hive::InvokedBinary,
+                     command_env: {})
+        @config_loader = config_loader
+        @project_root_resolver = project_root_resolver || method(:default_project_root)
+        @env = env
+        @command_env = command_env.to_h
+        @clock = clock
+        @command_runner = command_runner || method(:run_command)
+        @universal_checker = universal_checker || ->(cfg, project_root) {
+          Hive::Commands::Doctor.agent_health(config: cfg, project_root: project_root)
+        }
+        @invoked_binary = invoked_binary
+        @cache = {}
+      end
+
+      def clear_cache!
+        @cache.clear
+      end
+
+      def cheap_fingerprint(row, candidate)
+        project_root = @project_root_resolver.call(row)
+        cfg = @config_loader.call(project_root)
+        profile_name = candidate.reason == "implementer_failed" ? :codex : :claude
+        profile = Hive::AgentProfiles.lookup(profile_name, cfg: cfg)
+        fields = {
+          project: File.realpath(project_root), reason: candidate.reason,
+          profile: profile.name.to_s, bin: resolved_bin(profile),
+          bin_stat: stat_fingerprint(resolved_bin(profile)),
+          config: Digest::SHA256.hexdigest(Marshal.dump(relevant_config(cfg))),
+          env: relevant_env_digest(profile), hive: hive_identity
+        }
+        Digest::SHA256.hexdigest(canonical(fields))
+      rescue StandardError => e
+        "unavailable:#{Digest::SHA256.hexdigest(e.class.name)}"
+      end
+
+      def bundle_for(row, candidate)
+        cheap = cheap_fingerprint(row, candidate)
+        key = [ row.project.to_s, candidate.reason.to_s, cheap ]
+        return @cache[key] if @cache.key?(key)
+
+        project_root = @project_root_resolver.call(row)
+        cfg = @config_loader.call(project_root)
+        probes = universal_probes(cfg: cfg, project_root: project_root)
+        probes.concat(candidate.reason == "implementer_failed" ? codex_probes(cfg) : claude_probes(cfg, row, candidate))
+        healthy = probes.all?(&:healthy)
+        fingerprint = Digest::SHA256.hexdigest(canonical(
+          cheap: cheap, probes: probes.map { |probe| [ probe.name, probe.healthy, probe.exit_status, probe.timed_out, probe.fingerprint ] }
+        ))
+        @cache[key] = Bundle.new(healthy: healthy, reason: candidate.reason, probes: probes,
+                                 cheap_fingerprint: cheap, fingerprint: fingerprint)
+      rescue StandardError => e
+        probe = exception_probe("bundle", e)
+        @cache[key || [ row.project.to_s, candidate.reason.to_s, "error" ]] = Bundle.new(
+          healthy: false, reason: candidate.reason, probes: [ probe ], cheap_fingerprint: cheap, fingerprint: probe.fingerprint
+        )
+      end
+
+      private
+
+      def default_project_root(row)
+        entry = Hive::Config.find_project(row.project)
+        raise Hive::ConfigError, "unknown project #{row.project.inspect}" unless entry
+
+        entry.fetch("path")
+      end
+
+      def universal_probes(cfg:, project_root:)
+        rows = @universal_checker.call(cfg, project_root)
+        healthy = rows.all? { |row| %w[present not_applicable warning].include?(row[:status].to_s) }
+        [ in_process_probe("universal_agent_health", healthy, rows.map { |row| [ row[:label], row[:status] ] }) ]
+      rescue StandardError => e
+        [ exception_probe("universal_agent_health", e) ]
+      end
+
+      def codex_probes(cfg)
+        profile = Hive::AgentProfiles.lookup(:codex, cfg: cfg)
+        bin = resolved_bin(profile)
+        login = @command_runner.call(name: "codex_login_status", argv: [ bin, "login", "status" ], timeout_sec: STATUS_TIMEOUT_SEC)
+        login.healthy &&= login.stdout.match?(/\blogged\s+in\b/i)
+        login.fingerprint = probe_fingerprint(login)
+        smoke = codex_smoke(bin)
+        [ login, smoke ]
+      end
+
+      def codex_smoke(bin)
+        Dir.mktmpdir("hive-auto-retry-codex-", Dir.tmpdir) do |dir|
+          File.chmod(0o700, dir)
+          return unhealthy_probe("codex_smoke", "isolation_mode_unavailable") unless (File.stat(dir).mode & 0o077).zero?
+
+          probe = @command_runner.call(
+            name: "codex_smoke", argv: [ bin, "exec", "--sandbox", "read-only", "--ask-for-approval", "never", "Reply with OK." ],
+            timeout_sec: ACTIVE_TIMEOUT_SEC, cwd: dir
+          )
+          probe
+        end
+      rescue StandardError => e
+        exception_probe("codex_smoke", e)
+      end
+
+      def claude_probes(cfg, row, _candidate)
+        profile = Hive::AgentProfiles.lookup(:claude, cfg: cfg)
+        bin = resolved_bin(profile)
+        wrapper = File.expand_path("../scripts/interactive_claude_wrapper.sh", __dir__)
+        wrapper_ok = File.file?(wrapper) && !File.symlink?(wrapper) && File.readable?(wrapper)
+        probes = [
+          in_process_probe("claude_wrapper", wrapper_ok, stat_fingerprint(wrapper)),
+          in_process_probe("claude_ready_detector", Hive::ClaudeLauncher.ready_detector_self_check),
+          @command_runner.call(name: "claude_version", argv: [ bin, "--version" ], timeout_sec: STATUS_TIMEOUT_SEC),
+          @command_runner.call(name: "tmux_preflight", argv: [ @env.fetch("HIVE_TMUX_BIN", "tmux"), "-V" ], timeout_sec: STATUS_TIMEOUT_SEC)
+        ]
+        session = Hive::ClaudeLauncher.tmux_session_name(row.stage, Struct.new(:slug, :folder).new(row.slug, row.folder))
+        collision = @command_runner.call(name: "claude_target_session_absent", argv: [ @env.fetch("HIVE_TMUX_BIN", "tmux"), "has-session", "-t", session ], timeout_sec: STATUS_TIMEOUT_SEC)
+        collision.healthy = collision.exit_status == 1 && !collision.timed_out
+        collision.fingerprint = probe_fingerprint(collision)
+        probes << collision
+        probes << hive_identity_probe
+        probes
+      rescue StandardError => e
+        [ exception_probe("claude_bundle", e) ]
+      end
+
+      def hive_identity_probe
+        path = @invoked_binary.path(env: @env)
+        return unhealthy_probe("hive_identity", "invoked_binary_missing") unless path && File.file?(path)
+
+        @command_runner.call(name: "hive_identity", argv: [ path, "--version" ], timeout_sec: STATUS_TIMEOUT_SEC)
+      end
+
+      def resolved_bin(profile)
+        key = profile.env_bin_override_key
+        value = key && @env[key]
+        value && !value.empty? ? value : profile.bin_default
+      end
+
+      def run_command(name:, argv:, timeout_sec:, cwd: nil)
+        return unhealthy_probe(name, "invalid_argv") unless argv.is_a?(Array) && argv.all? { |part| part.is_a?(String) && !part.empty? }
+
+        started = @clock.call
+        reader, writer = IO.pipe
+        output = +""
+        pid = Process.spawn(bounded_env, *argv, chdir: cwd || Dir.tmpdir, pgroup: true, out: writer, err: writer)
+        writer.close
+        drain = Thread.new { reader.each { |part| output << part } }
+        status = nil
+        timed_out = false
+        until (status = Process.waitpid2(pid, Process::WNOHANG)&.last)
+          if @clock.call - started >= timeout_sec
+            timed_out = true
+            terminate_group(pid)
+            status = Process.waitpid2(pid)&.last
+            break
+          end
+          sleep 0.02
+        end
+        drain.join
+        duration = ((@clock.call - started) * 1000).round
+        probe = Probe.new(name: name, healthy: !timed_out && status&.success?, exit_status: status&.exitstatus,
+                          timed_out: timed_out, duration_ms: duration, stdout: capped(output), stderr: "")
+        probe.fingerprint = probe_fingerprint(probe)
+        probe
+      rescue SystemCallError, IOError => e
+        exception_probe(name, e)
+      ensure
+        writer&.close unless writer&.closed?
+        reader&.close unless reader&.closed?
+        drain&.kill if drain&.alive?
+      end
+
+      def terminate_group(pid)
+        Process.kill("TERM", -pid)
+        sleep 0.05
+        Process.kill("KILL", -pid)
+      rescue Errno::ESRCH, Errno::EPERM
+        nil
+      end
+
+      def bounded_env
+        SAFE_ENV_KEYS.each_with_object(@command_env.dup) { |key, env| env[key] = @env[key] if @env[key] }
+      end
+
+      def in_process_probe(name, healthy, value = nil)
+        probe = Probe.new(name: name, healthy: healthy == true, exit_status: nil, timed_out: false,
+                          duration_ms: 0, stdout: capped(value.to_s), stderr: "")
+        probe.fingerprint = probe_fingerprint(probe)
+        probe
+      end
+
+      def unhealthy_probe(name, message)
+        in_process_probe(name, false, message)
+      end
+
+      def exception_probe(name, exception)
+        probe = Probe.new(name: name, healthy: false, exit_status: nil, timed_out: false,
+                          duration_ms: 0, stdout: "", stderr: capped("#{exception.class}: #{exception.message}"))
+        probe.fingerprint = probe_fingerprint(probe)
+        probe
+      end
+
+      def capped(text)
+        redacted = Hive::SecretPatterns.redact(text.to_s).gsub(/\b(?:Bearer|Basic)\s+\S+/i, "[REDACTED:authorization]")
+        redacted.byteslice(0, OUTPUT_LIMIT).to_s.scrub
+      end
+
+      def probe_fingerprint(probe)
+        Digest::SHA256.hexdigest(canonical(name: probe.name, healthy: probe.healthy, exit_status: probe.exit_status,
+                                           timed_out: probe.timed_out, stdout: probe.stdout, stderr: probe.stderr))
+      end
+
+      def relevant_config(cfg)
+        { "claude" => cfg["claude"], "agents" => cfg["agents"], "brainstorm" => cfg["brainstorm"],
+          "plan" => cfg["plan"], "execute" => cfg["execute"] }
+      end
+
+      def relevant_env_digest(profile)
+        key = profile.env_bin_override_key
+        Digest::SHA256.hexdigest([ key, key && @env[key], @env["PATH"] ].join("\0"))
+      end
+
+      def hive_identity
+        path = @invoked_binary.path(env: @env)
+        { path: path, stat: stat_fingerprint(path) }
+      end
+
+      def stat_fingerprint(path)
+        return nil unless path && File.file?(path)
+
+        stat = File.stat(path)
+        Digest::SHA256.hexdigest([ File.realpath(path), stat.size, stat.mtime.to_f, Digest::SHA256.file(path).hexdigest ].join("\0"))
+      rescue SystemCallError
+        nil
+      end
+
+      def canonical(value)
+        case value
+        when Hash then "{" + value.keys.map(&:to_s).sort.map { |key| "#{key}:#{canonical(value[key] || value[key.to_sym])}" }.join(",") + "}"
+        when Array then "[#{value.map { |item| canonical(item) }.join(",")}]"
+        else value.to_s
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/dispatch_request_queue.rb b/lib/hive/daemon/dispatch_request_queue.rb
index 00d7aacc..6a8b03eb 100644
--- a/lib/hive/daemon/dispatch_request_queue.rb
+++ b/lib/hive/daemon/dispatch_request_queue.rb
@@ -13,7 +13,7 @@ module Hive
       module_function
 
       SCHEMA = "hive-dispatch-request".freeze
-      SCHEMA_VERSION = 2
+      SCHEMA_VERSION = 3
 
       ALLOWED_VERBS = %w[
         run develop brainstorm plan review open-pr artifacts finalize
@@ -30,7 +30,7 @@ module Hive
 
       Request = Struct.new(
         :request_id, :created_at, :project, :slug, :argv, :requestor,
-        :chat_id, :update_id, :trigger, :path,
+        :chat_id, :update_id, :trigger, :recovery, :path,
         keyword_init: true
       )
 
@@ -50,12 +50,14 @@ module Hive
 
       def write_request!(project:, slug:, argv:, requestor: "bot", chat_id: nil,
                          update_id: nil, trigger: nil, request_id: generate_request_id,
-                         state_home: Hive::Paths.state_home, now: Time.now)
+                         recovery: nil, state_home: Hive::Paths.state_home, now: Time.now)
         unless valid_argv?(argv)
           raise ArgumentError, "argv #{argv.inspect} is not allowlisted for dispatch requests"
         end
         raise ArgumentError, "project is required for dispatch requests" if project.to_s.empty?
         raise ArgumentError, "slug is required for dispatch requests" if slug.to_s.empty?
+        normalized_recovery = normalize_recovery(recovery)
+        raise ArgumentError, "recovery identity is invalid" if recovery && !normalized_recovery
 
         created_at = now.utc
         payload = {
@@ -71,6 +73,7 @@ module Hive
           "update_id" => update_id,
           "trigger" => trigger.to_s
         }
+        payload["recovery"] = normalized_recovery if normalized_recovery
 
         dir = directory(state_home: state_home)
         filename = filename_for(created_at: created_at, request_id: request_id)
@@ -272,7 +275,7 @@ module Hive
           return {
             chat_id: data["chat_id"], update_id: data["update_id"],
             project: data["project"], slug: data["slug"],
-            requestor: data["requestor"]
+            requestor: data["requestor"], recovery: data["recovery"]
           }
         end
         nil
@@ -361,6 +364,7 @@ module Hive
 
       def expired?(request, now: Time.now, expiry_sec: EXPIRY_SEC)
         return false unless request.respond_to?(:created_at)
+        return false if request.respond_to?(:recovery) && request.recovery
 
         created = request.created_at
         return false unless created.is_a?(Time)
@@ -498,6 +502,9 @@ module Hive
           created_at = parse_time(data["created_at"])
           return :invalid_created_at if created_at.nil?
 
+          recovery = normalize_recovery(data["recovery"])
+          return :invalid_recovery if data.key?("recovery") && recovery.nil?
+
           Request.new(
             request_id: request_id,
             created_at: created_at,
@@ -508,10 +515,27 @@ module Hive
             chat_id: data["chat_id"],
             update_id: data["update_id"],
             trigger: data["trigger"].to_s,
+            recovery: recovery,
             path: path
           )
         end
 
+        def normalize_recovery(value)
+          return nil if value.nil?
+          return nil unless value.is_a?(Hash)
+
+          normalized = value.transform_keys(&:to_s)
+          required = %w[task_id stage marker_id reason attempt]
+          return nil unless normalized.keys.sort == required.sort
+          return nil if normalized["task_id"].to_s.empty? || normalized["marker_id"].to_s.empty? ||
+                        normalized["reason"].to_s.empty?
+          return nil unless normalized["stage"].is_a?(String) &&
+                            /\A\d+-[a-z][a-z0-9-]*\z/.match?(normalized["stage"])
+          return nil unless normalized["attempt"].is_a?(Integer) && normalized["attempt"].between?(1, 2)
+
+          normalized.slice(*required)
+        end
+
         def parse_time(value)
           return nil if value.nil? || value.to_s.empty?
 
